import has from "lodash/has";

import { markdownConverter } from "markdown";
import { ProgramStore } from "stores";

export const handleProgramEntryChanged = (payload) => {
  ProgramStore.update((state) => {
    const entry = state.items[payload.id];

    if (entry) {
      if (has(payload, "discussion_opened")) {
        state.items[payload.id].discussionOpened = payload.discussion_opened;
      }
      if (has(payload, "title")) {
        state.items[payload.id].title = payload.title;
        state.items[payload.id].fullTitle =
          entry.number !== "" ? `${entry.number}. ${entry.title}` : entry.title;
      }
      if (has(payload, "description")) {
        state.items[payload.id].description = payload.description;
        state.items[payload.id].htmlContent = markdownConverter.makeHtml(
          payload.description
        );
      }
    }
  });
};
